//
// SizeChangedEventArgs.cs
//
// Contact:
//   Moonlight List (moonlight-list@lists.ximian.com)
//
// Copyright 2008 Novell, Inc.
//
// Permission is hereby granted, free of charge, to any person obtaining
// a copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to
// permit persons to whom the Software is furnished to do so, subject to
// the following conditions:
// 
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
// LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
// OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
// WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
//
//

using System;
using System.Security;
using Mono;

namespace System.Windows
{
	public class SizeChangedEventArgs : RoutedEventArgs
	{
		public SizeChangedEventArgs () : base (NativeMethods.size_changed_event_args_new ())
		{
		}

		internal SizeChangedEventArgs (IntPtr raw) : base (raw)
		{
		}

		public Size NewSize {
#if NET_2_1
			[SecuritySafeCritical]
#endif
			get {
				UnmanagedSize u = new UnmanagedSize();
				NativeMethods.size_changed_event_args_get_new_size (native, ref u);
				return new Size (u.width, u.height);
			}
		}

		public Size PreviousSize {
#if NET_2_1
			[SecuritySafeCritical]
#endif
			get {
				UnmanagedSize u = new UnmanagedSize();
				NativeMethods.size_changed_event_args_get_prev_size (native, ref u);
				return new Size (u.width, u.height);
			}
		}
	}
}
